package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaEmailFlexBusDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaEmailFlexBus;

@Repository("empresaEmailFlexBusDAO")
public class EmpresaEmailFlexBusHibernateDAO extends GenericHibernateDAO<EmpresaEmailFlexBus, Integer>
		implements EmpresaEmailFlexBusDAO {

	@Autowired
	public EmpresaEmailFlexBusHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<EmpresaEmailFlexBus> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public EmpresaEmailFlexBus buscarPorEmpresa(Empresa empresa) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa", empresa));

		return (EmpresaEmailFlexBus) c.uniqueResult();
	}
}
